{
    "$graph": [
        {
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": "string",
                    "id": "#echo.cwl/r"
                },
                {
                    "type": "string",
                    "default": "import sys\nprint(sys.argv[1])\nif sys.argv[1] == \"2\":\n  exit(1)\nelse:\n  f = open(\"foo\"+sys.argv[1]+\".txt\", \"wb\")\n  content = sys.argv[1]+\"\\n\"\n  f.write(content.encode('utf-8'))\nif sys.argv[1] == \"5\":\n  exit(1)\n",
                    "id": "#echo.cwl/script"
                }
            ],
            "arguments": [
                "python",
                "-c",
                "$(inputs.script)",
                "$(inputs.r)"
            ],
            "id": "#echo.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "foo$(inputs.r).txt"
                    },
                    "id": "#echo.cwl/out"
                }
            ]
        },
        {
            "class": "Workflow",
            "inputs": [],
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/step1/out",
                    "id": "#main/out1"
                },
                {
                    "type": "File",
                    "outputSource": "#main/step2/out",
                    "id": "#main/out2"
                },
                {
                    "type": "File",
                    "outputSource": "#main/step4/out",
                    "id": "#main/out4"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "default": "1",
                            "id": "#main/step1/r"
                        }
                    ],
                    "out": [
                        "#main/step1/out"
                    ],
                    "run": "#echo.cwl",
                    "id": "#main/step1"
                },
                {
                    "in": [
                        {
                            "default": "2",
                            "id": "#main/step2/r"
                        }
                    ],
                    "out": [
                        "#main/step2/out"
                    ],
                    "run": "#echo.cwl",
                    "id": "#main/step2"
                },
                {
                    "in": [
                        {
                            "default": "5",
                            "id": "#main/step3/r"
                        }
                    ],
                    "out": [
                        "#main/step3/out"
                    ],
                    "run": "#echo.cwl",
                    "id": "#main/step3"
                },
                {
                    "in": [
                        {
                            "source": "#main/step3/out",
                            "valueFrom": "$(inputs.r.basename)",
                            "id": "#main/step4/r"
                        }
                    ],
                    "out": [
                        "#main/step4/out"
                    ],
                    "run": "#echo.cwl",
                    "id": "#main/step4"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
